# ds_opencv

Cookbook to build and install OpenCV

## Supported versions

The following table describes which OpenCV versions this cookbook supports:

| Cookbook version | Ubuntu version | OpenCV versions | x86_64 binaries available |
|------------------|----------------|-----------------|---------------------------|
| 1.x              | 16.04          | 3.x             |                           |
| >= 2.0.0         | 18.04          | 3.x, 2.x        |                           |
| >= 2.1.0         | 18.04          | 4.x, 3.x, 2.x   |                           |
| >= 3.0.0         | 18.04          | 4.x, 3.x, 2.x   | 4.3.0                     |


## Usage

1. Include `ds_opencv::default` in your wrapper cookbook
2. Set the `node['ds_opencv']['opencv']['version']` in your wrapper.


## Packaging binaries for a new OpenCV version

Installing OpenCV from binary debian packages is substantially faster than compiling from source.
If you would like to add a binary for a version of OpenCV you are using in your cookbook, follow these steps:

1. Bump your downstream cookbook to ds_opencv 3.0.0 or later.
2. Either by using kitchen or an existing instance, collect the debian packages in /opt/opencv-VERSION/ (downloading with `scp -r instance:/opt/OPENCVDIR/*.deb ~/`) worked for me. Every installation of ds_opencv 3.0.0 or later includes flags to build these packages, however this is not the default.
3. Upload those debian packages to `s3:darksky-ops/pkg/opencv_public/` with a prefix that matches the existing format `CVVERSION-ARCH-UBUNTUVERSION`. Make sure those files (but not the whole bucket!) have public read permissions.
4. Add the name of each of those packages to the hash at the top of the default recipe in this repository.
5. Release a new version of this cookbook. You're good to go!
